//=============================================================
// Root Macro to check the format within this tree
//=============================================================
void CheckTree()
{
  gROOT->Reset();
  Int_t readDict     = 1;
  Int_t showBusErorr = 0;

  //this causes a crash when reading the tree.....
  if(readDict) {
    if (!TClassTable::GetDict("Signal")) {
      cout << "reading in definition" << endl;
      gSystem->Load("./libTNT2Event.so");
      //gROOT->ProcessLine(".L TNT2Event.cxx++");
      SamplePoint::Class()->IgnoreTObjectStreamer(); //Removed fUniqueId, fBits
      Signal::Class()->IgnoreTObjectStreamer();
    }
  }

  TFile *f = TFile::Open("TestEvent.root");
  f->ls();
  
  TTree *testT  = (TTree*) f->Get("testTree1");
  testT->Print();

  //if I load the dictionary this gives a bus error
  if(!readDict) {
    for(Int_t i = 0; i < 3; i++) {
      testT->Show(i);
    }
  } 
  else {
    //this causes a bus error......
    if(showBusErorr) {
      for(Int_t i = 0; i < 3; i++) {
	testT->Show(i);
      }
    }

    Signal *signal = new Signal();
    TBranch *bSignals = testT->GetBranch("OscBranch");
    bSignals->SetAddress(&signal);

    for(Int_t i = 0; i < 3; i++) {
      testT->GetEntry(i);
      signal->Dump();
      cout << signal->fTriggerCounter << endl;
      

      TClonesArray *samplePoints = new TClonesArray();
      samplePoints   = signal->GetSamples();
      Int_t nSamples = samplePoints->GetLast() + 1;
      cout << nSamples << endl;   //why is this zero ! related to error above ?

      SamplePoint  *sample = 0;

      for(Int_t n = 0; n < 10 && n < nSamples; n++) {
	sample = (SamplePoint *) samplePoints->At(n);
	//sample->Print();
	cout << sample->GetSamplePoint() << ",";
      }
      cout << endl;
    }
  }
}

/*
======> EVENT:0
 signals         = (Signal*)0x32a9460
 fTriggerCounter = 0
 fNSamples       = 2000
 fSamples        = 2000

 *** Break *** bus error
 fSamples.fPoint = /Users/hauschil/Analysis/Sorts/TNT2/test4/22862: No such file or directory.
Attaching to process 22862.
Reading symbols for shared libraries . done
Reading symbols for shared libraries .............. done
0x90029f07 in wait4 ()

========== STACKS OF ALL THREADS ==========

Thread 1 (process 22862 thread 0xd03):
#0  0x90029f07 in wait4 ()
#1  0x9004723b in system ()
#2  0x010d5410 in TUnixSystem::StackTrace ()
#3  0x010d8f25 in TUnixSystem::DispatchSignals ()
#4  0x010d9073 in SigHandler ()
#5  <signal handler called>
#6  0x03044957 in TStreamerInfo::PrintValueClones ()
#7  0x0348de0f in TBranchElement::PrintValue ()
#8  0x034c5d3b in TTree::Show ()
#9  0x034fb1f9 in G__G__Tree_109_0_174 ()
#10 0x019b0c4f in Cint::G__ExceptionWrapper ()
#11 0x01a93274 in G__execute_call ()
#12 0x01a936a6 in G__call_cppfunc ()
#13 0x01a6f0b5 in G__interpret_func ()
#14 0x01a5c8f2 in G__getfunction ()
#15 0x01b546ff in G__getstructmem ()
#16 0x01b53384 in G__getvariable ()
#17 0x01a0cc0c in G__getitem ()
#18 0x01a0f180 in G__getexpr ()
#19 0x01acf3c1 in G__exec_statement ()
#20 0x01ad4a40 in G__exec_loop ()
#21 0x01acf8e3 in G__exec_statement ()
#22 0x01a7106e in G__interpret_func ()
#23 0x01a5ccaa in G__getfunction ()
#24 0x01a0cd68 in G__getitem ()
#25 0x01a0f180 in G__getexpr ()
#26 0x01a292bc in G__calc_internal ()
#27 0x01ade4bc in G__process_cmd ()
#28 0x010c3449 in TCint::ProcessLine ()
#29 0x010c3632 in TCint::ProcessLineSynch ()
#30 0x0100f1eb in TApplication::ExecuteFile ()
#31 0x0100d340 in TApplication::ProcessLine ()
#32 0x00036a20 in TRint::Run ()
#33 0x00002ba3 in main ()
Root > Function CheckTree() busy flag cleared

.q

 *** Break *** bus error
/Users/hauschil/Analysis/Sorts/TNT2/test4/22862: No such file or directory.
Attaching to process 22862.
Reading symbols for shared libraries . done
Reading symbols for shared libraries .............. done
0x90029f07 in wait4 ()

========== STACKS OF ALL THREADS ==========

Thread 1 (process 22862 thread 0xd03):
#0  0x90029f07 in wait4 ()
#1  0x9004723b in system ()
#2  0x010d5410 in TUnixSystem::StackTrace ()
#3  0x010d8f25 in TUnixSystem::DispatchSignals ()
#4  0x010d9073 in SigHandler ()
#5  <signal handler called>
#6  0x03000002 in ?? ()
#7  0x000a28b8 in Signal::Clear ()
Previous frame inner to this frame (corrupt stack?)

*/
