//====================================================	
//====================================================	
#ifndef __TNT2Event__		
#define __TNT2Event__
//====================================================
#include "TObject.h"
#include "TClonesArray.h"


//===================================
// Classes to contain the signal data
//===================================

//-----------------------------------
// each sampled point
//-----------------------------------
class SamplePoint : public TObject {
 private:
  Short_t fPoint;
  
 public:
  SamplePoint();
  SamplePoint(const SamplePoint& orig);
  SamplePoint(Short_t sample);
  ~SamplePoint() {Clear();}
  
  void  Clear(Option_t *option="");
  
  //Short_t fPoint;
  void    SetSamplePoint(Short_t sample) { fPoint = sample;  }
  Short_t GetSamplePoint()         const { return fPoint; }
  
  ClassDef(SamplePoint, 1);
};


class Signal : public TObject {
 public:
  //could add Card Number here to allow merging of multiple cards
  UInt_t         fTriggerCounter;    //current event trigger number
  
  Int_t                fNSamples;    // number of samples in this oscillogram
  TClonesArray         *fSamples;    //->
  static TClonesArray  *fgSamples;   // used for initialisation

  Signal();                                //constructor
  Signal(const Signal &);                  //copy-constructor
  ~Signal();                       //destructor

  Signal &operator=(const Signal &rhs); //copy-in

  TClonesArray  *GetSamples()  const {return fSamples;}
  void           AddSamplePoint(Short_t sample);

  void Clear(Option_t *option = "");

  ClassDef(Signal, 1);
};
#endif