//======================================
// Started as a macro to test Classes
//======================================
#include <stdlib.h>
#include <stdio.h>
#include <iostream>
using namespace std;

#include "TNT2Event.h"
void TestEvent();

//----------------------------------
//create a "main" when not using CINT
//----------------------------------
#ifndef __CINT__
#include "TROOT.h"
#include "TFile.h"
#include "TDirectoryFile.h"
#include "TBufferFile.h"
#include "TTree.h"
#include "TBranch.h"
#include "TObject.h"

//----------------------------------
int main() 
{
  TestEvent();
  return 1;
}
#endif


//----------------------------------
//----------------------------------
void TestEvent()
{
#ifdef __CINT__
  gSystem->Load("./libTNT2Event.so");
#endif
  
  TFile* f = new TFile("TestEvent.root","RECREATE","");
  f->SetCompressionLevel(3);

  //=====================================================
  // SamplePoint TClonesArray of sampled points.....
  SamplePoint::Class()->IgnoreTObjectStreamer();   //Remove fUniqueId, fBits
  
  //======================================
  //Test creating a new signal 
  Signal::Class()->IgnoreTObjectStreamer();   //Remove fUniqueId, fBits

  //=================================================
  //Create and fill a tree......
  TTree* testTree1 = new TTree("testTree1","test1");
  Signal *nSig  = new Signal();
  //Signal nSig;
  //testTree1->Branch("OscBranch",&nSig);
  testTree1->Branch("OscBranch","Signal",&nSig,8000,99);

  for(Int_t n = 0; n < 50; n++) {
    nSig->Clear();
    nSig->fTriggerCounter = n;
    
    //add some sample data
    for(Int_t s = 1; s <= 2000; s++)
      nSig->AddSamplePoint(n+s);
  
    testTree1->Fill();
  }

  f->Write();
  f->Close();  
  return;
}
